\name{FSAtools-news}
\title{FSAtools package NEWS}
\section{Changes in version 2.0.5 (2023-08-18)}{
  \itemize{
    \item{generic.process() now normalizes the output path to avoid problems on Windows.}
    \item{Internal functions renamed to avoid false positive detection as methods.}
    \item{Invisible return value added to methods without return.}
    \item{fusion.process() has no longer an output default value, per CRAN policy.}
  }
}
\section{Changes in version 2.0.4 (2022-10-10)}{
  \itemize{
    \item{align.fsa() now exports R-squared as attribute.}
    \item{plot.fsa() bug on colors fixed.}
  }
}
\section{Changes in version 2.0.3 (2021-07-13)}{
  \itemize{
    \item{Minor updates for CRAN submission.}
    \item{genotype...() functions now preserve peak order.}
  }
}
\section{Changes in version 2.0.2 (2021-02-25)}{
  \itemize{
    \item{generic.log() entry point added.}
    \item{'nowarn' modifier added to design files for generic.process().}
    \item{Design files and generic.process() now accept multiple modifiers separated by commas.}
  }
}
\section{Changes in version 2.0.1 (2021-02-16)}{
  \itemize{
    \item{'include' and 'exclude' arguments added to generic.process().}
  }
}
\section{Changes in version 2.0.0 (2020-08-17)}{
  \itemize{
    \item{MLPA becomes FSAtools, as it is now generic enough for other applications. GEP.process() and GEP.interface() are replaced by generic.process() and generic.interface(), with an enhanced (not retrocompatible) design file specification (see designFile() help page).}
    \item{New design, example files, and genotype.(...).fsa functions added to illustrate the genotyping application.}
    \item{peaks.fsa() and classify() now updates a fsa object as align.fsa() does rather than returning R variables.}
    \item{Multiple function addition and replacement to better fit the new pipeline paradigm.}
	\item{'lowess' and 'lowess.top' arguments replace 'applyLowess' in read.fsa().}
	\item{filter.fsa() added.}
	\item{align.fsa() now detects and discards peaks corresponding to channel leakages.}
	\item{align.fsa() now dies properly if there is no peak.}
	\item{Sample name, well and run name now extracted by read.fsa().}
	\item{'runMetaData' attribute becomes 'metaData'.}
	\item{'legend.x' argument added to plot.fsa().}
  }
}
\section{Changes in version 1.10.1 (2020-06-09)}{
  \itemize{
    \item{align.fsa(rescue=TRUE) is now more resilient to failures.}
  }
}
\section{Changes in version 1.10.0 (2020-04-27)}{
  \itemize{
    \item{Fusion detection functions added.}
  }
}
\section{Changes in version 1.9.5 (2019-10-28)}{
  \itemize{
    \item{plot() method added for fsaModel objects, now used in classify().}
  }
}
\section{Changes in version 1.9.4 (2019-08-13)}{
  \itemize{
    \item{'overwrite' argument added to designFile() and MLPA.process().}
    \item{train() function added.}
    \item{MLPA.process() now uses plot.fsa(..., title=...).}
    \item{Cosmetic changes to plots generated by align.fsa(rescue=TRUE).}
  }
}
\section{Changes in version 1.9.3 (2018-04-25)}{
  \itemize{
    \item{Meta-data collection fixed and hardened in read.fsa().}
    \item{'meta.extra' argument added to read.fsa().}
    \item{'bool' type implemented in read.abif().}
    \item{Clearer error message in align.fsa() when R-squared is NA.}
  }
}
\section{Changes in version 1.9.2 (2016-07-29)}{
  \itemize{
    \item{Published on Github.}
  }
}
\section{Changes in version 1.9.1 (2016-05-15)}{
  \itemize{
    \item{Enhanced compatibility with older ABI fragment analyzers (read.fsa).}
    \item{align.fsa() no longer tries to postpone "missing channel" errors.}
    \item{align.fsa() and plot.fsa() now list available channels when asked for an unknown one.}
    \item{align.fsa() now prints the R squared value in recue mode.}
    \item{classify() no longer merges multiples gray zones into a single one.}
  }
}
\section{Changes in version 1.9.0 (2015-07-02)}{
  \itemize{
    \item{Enhanced compatibility with older ABI fragment analyzers.}
    \item{'processed' argument added to read.fsa(), preserving previous behavior as default (FALSE).}
    \item{'useLadder' in align.fsa() now handles the NULL value.}
    \item{'trim' argument added to align.fsa(), previous behavior is 'forward' (default).}
    \item{align.fsa() now postpones error messages to enforce plotting.}
    \item{align.fsa() and plot.fsa() now raise clearer error messages for missing channel.}
    \item{plot.fsa() now handles empty objects.}
    \item{plot.fsa() no longer overplots axes.}
    \item{'gene.cex', 'file.line' and 'mar' arguments added to MLPA.process(), also handled by the design file.}
  }
}
\section{Changes in version 1.8.5 (2014-12-16)}{
  \itemize{
    \item{Several minor modifications to classify(), plot.fsa() and MLPA.process() to enhance visual output.}
    \item{Primer peak excluded from peaks.fsa()' "low profile" check.}
    \item{'nticks' argument added to plot.fsa(), now defaulting to 5 rather than 1.}
  }
}
\section{Changes in version 1.8.4 (2014-09-17)}{
  \itemize{
    \item{Examplar designs update.}
  }
}
\section{Changes in version 1.8.3 (2014-06-16)}{
  \itemize{
    \item{'noiseRange' argument added to peaks.fsa().}
    \item{peaks.fsa() now warns about values under the noise level.}
    \item{'injectionTime' metadata extraction added to read.fsa().}
    \item{Right clic on a text entry in MLPA.interface() now empties it.}
    \item{MLPA.process() now produces PDF files with titles.}
  }
}
\section{Changes in version 1.8.2 (2014-06-02)}{
  \itemize{
    \item{'logTransform' argument added to getMax().}
    \item{'lowThreshold' argument added to getMax().}
    \item{Error while processing profiles with a single off-scale value corrected.}
    \item{getMax() renamed into peaks.fsa() and added to the design file.}
    \item{MLPA.process() with rescue.conf now also prints sample names.}
    \item{'rescue' mode of align.fsa() no longer crashes whith maskOffScale = TRUE.}
  }
}
\section{Changes in version 1.8.1 (2014-03-14)}{
  \itemize{
    \item{Examplar designs converted to Windows EOL for better compatibility.}
    \item{Examplar designs now only enforces non-default parameters.}
    \item{'rescue' argument added to align.fsa(), "rescue.conf" updated accordingly.}
    \item{Designs with empty PEAKS section no longer raise errors in designFile().}
    \item{align.fsa() no longer stops if too many peaks are detected, warns instead.}
    \item{align.fsa() default for 'fullLadder' is now complete.}
    \item{designFile() no longer warns if an argument is set to default, sends a message instead.}
    \item{MLPA.interface() now displays warning counts at the end of processing, if any.}
    \item{read.fsa() and MLPA.process() now handle a selection of metadata from the FSA file.}
    \item{model() no longer enforces a default for 'groupNames'.}
  }
}
\section{Changes in version 1.8.0 (2014-02-28)}{
  \itemize{
    \item{model() and classify() added, designFile() modified accordingly.}
    \item{Commas replaced by tabulations in designFile() for vectors.}
    \item{Normalization now occurs in getMax().}
    \item{getPeaks() and Ruminy... functions deleted, as deprecated.}
    \item{align.fsa() can now mask indexes with off-scale value in any channel.}
    \item{Package dataset replaced.}
    \item{Rescue design added.}
    \item{MLPA.process() now reminds design file in log (with MD5 checksum if available).}
    \item{plot.fsa() better handles 'chanColors' when 'channels' is not default.}
    \item{"rescue.conf" design file added.}
  }
}
\section{Changes in version 1.7.1 (2014-01-31)}{
  \itemize{
    \item{MLPA.interface() manual resizing better controled.}
    \item{Trailing spaces and tabulations no longer invalidate design files.}
    \item{'chanCol' argument to plot.fsa() renamed into 'chanColors'.}
    \item{'units', 'channels', 'chanCol', 'xlab', 'xlim', 'ylim' and 'xaxp' default values turned to NA.}
    \item{"[plot.fsa]" section now handled by designFile().}
    \item{'xlim' and 'ylim' removed from MLPA.interface() and MLPA.process() (moved into design).}
    \item{"[align.fsa]" and "[plot.fsa]" sections are now optional in design files.}
    \item{'modelMode' removed from MLPA.interface() and MLPA.process() until implementation.}
    \item{ 4 more examples of .fsa files shiped in the 'extdata' directory.}
  }
}
\section{Changes in version 1.7.0 (2014-01-29)}{
  \itemize{
    \item{Applied Biosystems' binary converter replaced by seqinr package's read.abif(), enabling compatibility with most operating systems.}
    \item{Dependency to XML package dropped, dependency to tcltk made optional.}
    \item{Windows file selection dialogues replaced by Tcl-tk ones.}
    \item{Examples added to most of the help pages.}
    \item{offScale attribute in 'fsa' objects simplified as vectors (channel data seems spurious).}
    \item{outThreshold argument in align.fsa() can now be defined as a proportion (new default value).}
    \item{MLPA.interface() no longer proposes a default design path (second occurence removed).}
    \item{modelizeNoise() deleted, as deprecated.}
  }
}
\section{Changes in version 1.6.0 (2014-01-24)}{
  \itemize{
    \item{Design files now include more settings, old files must be rewritten accordingly.}
    \item{An example of design file is now provided in the package directory.}
    \item{align.fsa() rewritten for more precision and robustness (may invalidate old intervals).}
    \item{MLPA.interface() gave birth to MLPA.process() for harmonization with CLI processing.}
    \item{Peak mode option removed from MLPA.interface().}
    \item{MLPA.interface() is now resizable.}
    \item{plot.fsa() no longer plots offscale values from unselected channels.}
    \item{ruminyLPS() is now exported in the NAMESPACE.}
    \item{read.fsa() now expects NA for default converter, no more NULL.}
    \item{MLPA.interface() no longer proposes a default design path.}
  }
}
\section{Changes in version 1.5.0 (2013-02-12)}{
  \itemize{
    \item{off-scale values no longer replaced by Inf.}
    \item{'offScaleValues' attribute removed from class 'fsa'.}
    \item{'peak.offScale' column added to getMax() and getPeaks().}
    \item{off-scale behavior added to MLPA.interface().}
    \item{'offScale' colnames enforced when no off-scale value is detected in read.fsa().}
    \item{'Output table' and 'Output image file' merged in MLPA.interface().}
    \item{SVG support removed from MLPA.interface().}
    \item{Warnings and messages redirected to a log file in MLPA.interface().}
    \item{Empty colors now supported in design for MLPA.interface().}
    \item{designFile() added.}
    \item{Ruminy's classifier functions added.}
    \item{Expression matrix output file added to MLPA.interface().}
  }
}
\section{Changes in version 1.4.2 (2013-02-08)}{
  \itemize{
    \item{R errors, warnings and messages now print the concerned file names or stages.}
    \item{'color' column added to MLPA.interface() design file.}
    \item{'excess' argument added to align.fsa(), with "warn" default rather than previous "stop"-like behavior.}
  }
}
\section{Changes in version 1.4.1 (2013-02-05)}{
  \itemize{
    \item{Background color for MLPA.interface plots lightened.}
    \item{Print method for fsa class added.}
    \item{off-scale value detection added to read.fsa().}
    \item{plot.fsa() nrow supports infinite y values.}
    \item{XML conversion of FSA files now removed on exit.}
    \item{MLPA.interface default switched from 'local max' to 'global max'.}
  }
}
